VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Selection"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'Dim oldx As Integer
'Dim oldy As Integer
'Dim curdrwwidth As Integer
'Dim curdrwheight As Integer

Dim firstX As Integer
Dim firstY As Integer

'Dim selsourcex As Integer
'Dim selsourcey As Integer

Dim tempboundaries As RECT

Dim dragxcorrection As Integer
Dim dragycorrection As Integer

Enum selectionstate
    NotDrawing
    drawing
    append
End Enum

Dim c_selstate As selectionstate

Dim seltilestartx As Integer
Dim seltilestarty As Integer
Dim seltileendx As Integer
Dim seltileendy As Integer

Dim parent As frmMain

Dim undoch As Changes

Dim seltiles() As Integer
Dim isInSelection() As Boolean

Public hasAlreadySelectedParts As Boolean

Dim selectionchanged As Boolean
Dim selectioncancelled As Boolean

Dim boundaries As RECT

Private Sub Class_Initialize()
    boundaries.top = 32767
    boundaries.left = 32767
    boundaries.right = 0
    boundaries.bottom = 0
    tempboundaries.top = 32767
    tempboundaries.left = 32767
    tempboundaries.right = 0
    tempboundaries.bottom = 0
    
    ReDim seltiles(1024, 1024)
    ReDim isInSelection(1024, 1024)
    
End Sub

Sub setParent(ByRef main As frmMain)
    Set parent = main
End Sub

Function getIsInSelection(i As Integer, j As Integer) As Boolean
    getIsInSelection = isInSelection(i, j)
End Function

Sub setInSelection(i As Integer, j As Integer)
    isInSelection(i, j) = True
End Sub

Function isEdge(i As Integer, j As Integer) As Boolean
   On Error GoTo isEdge_Error

    If isInSelection(i - 1, j) And isInSelection(i, j - 1) And _
       isInSelection(i + 1, j) And isInSelection(i, j + 1) Then
        isEdge = False
    Else
        isEdge = True
    End If

   On Error GoTo 0
   Exit Function

isEdge_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure isEdge of Class Module Selection"
End Function

Friend Function getBoundaries() As RECT
    getBoundaries = boundaries
End Function

Public Property Get selstate() As selectionstate
    selstate = c_selstate
End Property

Public Property Let selstate(ByVal newselstate As selectionstate)
    c_selstate = newselstate
End Property

Sub MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim curtilex As Integer
    Dim curtiley As Integer
    
    'calculate tile coordinates
   On Error GoTo MouseDown_Error

    curtilex = (Int(((parent.hScr.value + X)) / (TileW * parent.magnifier.Zoom)))
    curtiley = (Int(((parent.vscr.value + Y)) / (TileH * parent.magnifier.Zoom)))

    firstX = curtilex
    firstY = curtiley

    If curtilex > 1023 Then curtilex = 1023
    If curtilex < 0 Then curtilex = 0
    If curtiley > 1023 Then curtiley = 1023
    If curtiley < 0 Then curtiley = 0
    
    If selstate = append Then
        'check if we click inside the selection or outside, and with which button
        If Button = vbRightButton Then
            ApplySelection
        ElseIf Button = vbLeftButton Then
            'If isInSelection(curtilex, curtiley) And _
            '    Shift <> 1 And Shift <> 2 Then
            If isInSelection(curtilex, curtiley) And ((parent.pastetype <> p_normal And seltiles(curtilex, curtiley) <> 0) Or parent.pastetype = p_normal) And _
                Shift <> 1 And Shift <> 2 Then
            'we clicked in the selection, ready to move
                dragxcorrection = curtilex
                dragycorrection = curtiley
            ElseIf Shift = 1 Or Shift = 2 Then
                'we want to draw if we clicked outside of selection or
                ' if we use shift or ctrl

                'we want to draw again
                selstate = drawing
                Call initDrawing(X, Y)
            Else
                ApplySelection
            End If
        End If
    End If
    
    If selstate = NotDrawing Then
        'we want to start drawing
        Call initDrawing(X, Y)
    End If
    
    'Check if we tried to cancel selection by right-clicking
    If selstate = drawing And Button = vbRightButton Then
        'Clear selection
        selectioncancelled = True
        Call MouseUp(Button, Shift)
        
    End If
    
   On Error GoTo 0
   Exit Sub

MouseDown_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseDown of Class Module Selection"
End Sub

Sub MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim curtilex As Integer
    Dim curtiley As Integer
    
   On Error GoTo MouseMove_Error

    'calculate tile coordinates
    curtilex = (Int(((parent.hScr.value + X)) / (TileW * parent.magnifier.Zoom)))
    curtiley = (Int(((parent.vscr.value + Y)) / (TileH * parent.magnifier.Zoom)))

    If curtilex > 1023 Then curtilex = 1023
    If curtilex < 0 Then curtilex = 0
    If curtiley > 1023 Then curtiley = 1023
    If curtiley < 0 Then curtiley = 0

    If hasAlreadySelectedParts And isInSelection(curtilex, curtiley) And ((parent.pastetype <> p_normal And seltiles(curtilex, curtiley) <> 0) Or parent.pastetype = p_normal) And _
       Shift <> 1 And Shift <> 2 Then
        parent.picpreview.MousePointer = 5
    Else
        parent.picpreview.MousePointer = 2
    End If
    
    If Not SharedVar.MouseDown Then
        Exit Sub
    End If
        
    If selstate = drawing Then
        
        'Swap first/current values if needed
        If firstX < curtilex Then
            seltilestartx = firstX
            seltileendx = curtilex
        Else
            seltilestartx = curtilex
            seltileendx = firstX
        End If
        
        If firstY < curtiley Then
            seltilestarty = firstY
            seltileendy = curtiley
        Else
            seltilestarty = curtiley
            seltileendy = firstY
        End If
        
        
        'update the drawing rectangle
        parent.shpdraw.left = (seltilestartx * TileW * parent.magnifier.Zoom) - parent.hScr.value
        parent.shpdraw.top = (seltilestarty * TileH * parent.magnifier.Zoom) - parent.vscr.value
        parent.shpdraw.Width = (seltileendx - seltilestartx + 1) * TileW * parent.magnifier.Zoom
        parent.shpdraw.Height = (seltileendy - seltilestarty + 1) * TileH * parent.magnifier.Zoom
    
    ElseIf selstate = append Then
        
        If Button = vbLeftButton Then
        'we are dragging the selection around
            Call Move(curtilex - dragxcorrection, curtiley - dragycorrection)
            
            dragxcorrection = curtilex
            dragycorrection = curtiley
        End If
   
    End If

   On Error GoTo 0
   Exit Sub

MouseMove_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseMove of Class Module Selection"

End Sub

Sub MouseUp(Button As Integer, Shift As Integer)
    
   On Error GoTo MouseUp_Error

    If Not selectioncancelled Then

        If parent.magnifier.UsingPixels Then
            'stupid selection on stupid pixel level has wrong offsets
            'because of the +2, but thats needed in non-pixel level
            'to have the correct tile start
            seltilestartx = (Int((parent.hScr.value + parent.shpdraw.left) / (TileW * parent.magnifier.Zoom)))
            seltilestarty = (Int((parent.vscr.value + parent.shpdraw.top) / (TileH * parent.magnifier.Zoom)))
            seltileendx = seltilestartx + (parent.shpdraw.Width / (TileW * parent.magnifier.Zoom)) - 1
            seltileendy = seltilestarty + (parent.shpdraw.Height / (TileH * parent.magnifier.Zoom)) - 1
        Else
            seltilestartx = (Int((parent.hScr.value + parent.shpdraw.left + 2) / (TileW * parent.magnifier.Zoom)))
            seltilestarty = (Int((parent.vscr.value + parent.shpdraw.top + 2) / (TileH * parent.magnifier.Zoom)))
            seltileendx = seltilestartx + (parent.shpdraw.Width / (TileW * parent.magnifier.Zoom)) - 1
            seltileendy = seltilestarty + (parent.shpdraw.Height / (TileH * parent.magnifier.Zoom)) - 1
        End If
        
        If Button = vbLeftButton And selstate = drawing Then
            If Shift = 2 Then 'ctrl
                Call RemoveSelectionArea(seltilestartx, seltileendx, seltilestarty, seltileendy)
            ElseIf Shift = 1 Then ' shift
                Call AddSelectionArea(seltilestartx, seltileendx, seltilestarty, seltileendy)
            Else
                If hasAlreadySelectedParts Then
                    Call AddSelectionArea(seltilestartx, seltileendx, seltilestarty, seltileendy)
                Else
                    Call ApplySelection
                    Call AddSelectionArea(seltilestartx, seltileendx, seltilestarty, seltileendy)
                End If
            End If
            selstate = append
        Else
            'We have right-clicked, so we're not adding anything to the selection
        End If
        
    Else
        If Button = vbRightButton Then
            'Hide the selection rectangle
            parent.shpdraw.Visible = False
            parent.shpdraw.left = 0
            parent.shpdraw.top = 0
            parent.shpdraw.Width = 1
            parent.shpdraw.Height = 1
        Else
            selectioncancelled = False
            hasAlreadySelectedParts = areThereTilesInSelection
            selstate = append
        End If
    End If
    
    parent.shpdraw.Visible = False
    parent.UpdatePreview

   On Error GoTo 0
   Exit Sub

MouseUp_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure MouseUp of Class Module Selection"
    
End Sub

Sub initDrawing(X As Single, Y As Single)
    Dim curtilex
    Dim curtiley
    
    
   On Error GoTo initDrawing_Error

    c_selstate = drawing
    parent.shpdraw.Visible = True
    
    'determine starting point of the selection
    curtilex = (Int(((parent.hScr.value + X)) / (TileW * parent.magnifier.Zoom)))
    curtiley = (Int(((parent.vscr.value + Y)) / (TileH * parent.magnifier.Zoom)))

    
    parent.shpdraw.left = (curtilex * TileW * parent.magnifier.Zoom) - parent.hScr.value
    parent.shpdraw.top = (curtiley * TileH * parent.magnifier.Zoom) - parent.vscr.value
    parent.shpdraw.Width = 1
    parent.shpdraw.Height = 1
    
    'curdrwwidth = 0
    'curdrwheight = 0
    'oldx = Int(x / (TileW * parent.magnifier.Zoom)) * (TileW * parent.magnifier.Zoom)
    'oldy = Int(y / (TileH * parent.magnifier.Zoom)) * (TileH * parent.magnifier.Zoom)

    hasAlreadySelectedParts = False

   On Error GoTo 0
   Exit Sub

initDrawing_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure initDrawing of Class Module Selection"
    
End Sub

Function areThereTilesInSelection()
    Dim i As Integer
    Dim j As Integer
    
    For j = 0 To 1023
        For i = 0 To 1023
            If isInSelection(i, j) Then
                areThereTilesInSelection = True
                Exit Function
            End If
        Next
    Next
    
    areThereTilesInSelection = False
    
End Function

Sub AddSelectionArea(seltilestartx As Integer, seltileendx As Integer, seltilestarty As Integer, seltileendy As Integer, Optional refresh As Boolean = True)
    Dim i As Integer
    Dim j As Integer

   On Error GoTo AddSelectionArea_Error

    Dim hasAdded As Boolean
    hasAdded = False
    
    
    If boundaries.left > seltilestartx Then boundaries.left = seltilestartx
    If boundaries.right < seltileendx Then boundaries.right = seltileendx
    If boundaries.top > seltilestarty Then boundaries.top = seltilestarty
    If boundaries.bottom < seltileendy Then boundaries.bottom = seltileendy
    tempboundaries = boundaries
    
    For j = seltilestarty To seltileendy
        For i = seltilestartx To seltileendx
            If Not isInSelection(i, j) Then
                If isTileSpecial(parent, i, j) Then
                    'special tile found, add it completly
                    Call AddObjectSelectionArea(i, j)
                    
                    If tempboundaries.left < boundaries.left Then boundaries.left = tempboundaries.left
                    If tempboundaries.right > boundaries.right Then boundaries.right = tempboundaries.right
                    If tempboundaries.top < boundaries.top Then boundaries.top = tempboundaries.top
                    If tempboundaries.bottom > boundaries.bottom Then boundaries.bottom = tempboundaries.bottom
                    
                Else
                    'copy all the tiles to the selection array
                    Call setSelTile(i, j, parent.getTile(i, j))
                    'remove the tiles from the level
                    Call parent.setTile(i, j, 0, undoch, False)
                    Call parent.UpdateLevelTile(i, j, False, False)
                    'flag that they are on the selection
                    isInSelection(i, j) = True
                End If
                hasAdded = True
            End If
        Next
    Next

    
    hasAlreadySelectedParts = True
    
    If refresh Then
        parent.pic1024selection.refresh
        frmGeneral.UpdateToolbarButtons
        parent.UpdateLevel
    End If
    
   On Error GoTo 0
   Exit Sub

AddSelectionArea_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure AddSelectionArea of Class Module Selection"
End Sub

Sub RemoveSelectionArea(seltilestartx As Integer, seltileendx As Integer, seltilestarty As Integer, seltileendy As Integer, Optional refresh As Boolean = True)
    Dim i As Integer
    Dim j As Integer
    Dim coordx As Integer
    Dim coordy As Integer
    
   On Error GoTo RemoveSelectionArea_Error

    tempboundaries = boundaries
    
    'check for special objects being removed

    For j = seltilestarty To seltileendy
        For i = seltilestartx To seltileendx
            If isInSelection(i, j) Then
                If isSelTileSpecial(Me, i, j) Then
                    'special tile found, removing it completly
                    Call RemoveObjectSelectionArea(i, j)
                    
                Else
                    Call parent.setTile(i, j, seltiles(i, j), undoch, False)
                    Call parent.UpdateLevelTile(i, j, False)
                    'remove the tiles from the selection
                    Call setSelTile(i, j, 0, False)
                    'flag that they are on the selection
                    isInSelection(i, j) = False
                    Call SetPixel(parent.pic1024selection.hdc, i, j, vbWhite)
                End If
            End If
        Next
    Next
    
    
    For j = seltilestarty To seltileendy
        For i = seltilestartx To seltileendx
            If isInSelection(i, j) Then
                'copy all the tiles to the level array
                Call parent.setTile(i, j, seltiles(i, j), undoch, False)
                Call parent.UpdateLevelTile(i, j, False)
                'remove the tiles from the selection
                Call setSelTile(i, j, 0, False)
                'flag that they are on the selection
                isInSelection(i, j) = False
                Call SetPixel(parent.pic1024selection.hdc, i, j, vbWhite)
            End If
        Next
    Next
    

    ' check if we need to shrink the left side
    'If seltilestartx <= tempboundaries.Left Then
        j = 0: i = 0
        For j = tempboundaries.left To boundaries.right
            For i = 0 To 1023
                If isInSelection(j, i) Then
                    GoTo skipleft
                End If
            Next
            tempboundaries.left = tempboundaries.left + 1
        Next
    'End If
skipleft:
               
    ' check if we need to shrink the top side
    'If seltilestarty <= tempboundaries.Top Then
        j = 0: i = 0
        For j = tempboundaries.top To boundaries.bottom
            For i = 0 To 1023
                If isInSelection(i, j) Then
                    GoTo skiptop
                End If
            Next
            tempboundaries.top = tempboundaries.top + 1
        Next
    'End If
skiptop:
    
    ' check if we need to shrink the right side
    'If seltileendx >= tempboundaries.Right Then
        j = 0: i = 0
        For j = tempboundaries.right To boundaries.left Step -1
            For i = 0 To 1023
                If isInSelection(j, i) Then
                    GoTo skipright
                End If
            Next
            tempboundaries.right = tempboundaries.right - 1
        Next
    'End If
skipright:

    ' check if we need to shrink the right side
    'If seltileendy >= tempboundaries.Bottom Then
        j = 0: i = 0
        For j = tempboundaries.bottom To boundaries.top Step -1
            For i = 0 To 1023
                If isInSelection(i, j) Then
                    GoTo skipbottom
                End If
            Next
            tempboundaries.bottom = tempboundaries.bottom - 1
        Next
    'End If
skipbottom:

     boundaries = tempboundaries
    
    If refresh Then
        'check if there are any tiles left in selection
        hasAlreadySelectedParts = areThereTilesInSelection
        If Not hasAlreadySelectedParts Then
            parent.pic1024selection.Cls
        End If
        
        frmGeneral.UpdateToolbarButtons
        parent.UpdateLevel
    End If
    
   On Error GoTo 0
   Exit Sub

RemoveSelectionArea_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure RemoveSelectionArea of Class Module Selection"
End Sub



Sub ApplySelection()

   On Error GoTo ApplySelection_Error


    parent.undoredo.ResetRedo
    Dim undoch As Changes
    Set undoch = New Changes

    
'apply selection is nothing more than removeselection but on the whole selection
'array, rather than a part of it
    
        Dim i As Integer
        Dim j As Integer
        
        For j = boundaries.top To boundaries.bottom
            For i = boundaries.left To boundaries.right
                If isInSelection(i, j) And (selectionchanged Or seltiles(i, j) <> 0) Then
                    'copy all the tiles to the level array
                    

                        
                    'check for draw type
                    If Not seltiles(i, j) = -1 And _
                        ((parent.pastetype = p_normal) Or _
                        (parent.pastetype = p_trans And seltiles(i, j) <> 0) Or _
                        (parent.pastetype = p_under And parent.getTile(i, j) = 0 And AreaClearForObject(parent, i, j, seltiles(i, j)))) Then
                        If isSelTileSpecial(Me, i, j) Then
                            Call setObject(parent, seltiles(i, j), i, j, undoch, False)
                        Else
                            Call parent.setTile(i, j, seltiles(i, j), undoch, False)
                            Call parent.UpdateLevelTile(i, j, False)
                        End If
                    End If


                End If

            Next
        Next
 
    hasAlreadySelectedParts = False
    parent.pic1024selection.Cls
    
    'Call parent.UpdateLevel
    
    'reset selection state
    c_selstate = NotDrawing
    selectionchanged = False
    
    boundaries.top = 32767
    boundaries.left = 32767
    boundaries.right = 0
    boundaries.bottom = 0
    
    
    'clear possible tile nr's stored in unused selection tiles
    Call DeleteSelection
    
    Call parent.undoredo.AddToUndo(undoch)


   On Error GoTo 0
   Exit Sub

ApplySelection_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure ApplySelection of Class Module Selection"
    
End Sub

Sub CopySelection()
    'set the array into the clipboard array
    Call parent.clip.SetClipboardData(seltiles, isInSelection, boundaries)
    
End Sub

Sub CutSelection()
    'set the array into the clipboard array
    'remove the selection
    CopySelection
    DeleteSelection
End Sub

Sub DeleteSelection()
'clear the selection, but don't copy the tiles from the selection to the level
    Erase isInSelection
    Erase seltiles
    ReDim isInSelection(1024, 1024)
    ReDim seltiles(1024, 1024)
    
    parent.UpdateLevel
    
End Sub

Sub DrawCornerLinesOn(i As Integer, j As Integer, lbx As Integer, lby As Integer)
    Dim X As Integer
    Dim Y As Integer
    
   On Error GoTo DrawCornerLinesOn_Error

    On Error Resume Next
    
    If parent.pastetype <> p_normal And seltiles(i, j) = 0 Then
        Exit Sub
    End If
    
    X = (i - lbx) * (TileW * parent.magnifier.Zoom)
    Y = (j - lby) * (TileH * parent.magnifier.Zoom)
    
    If Not isInSelection(i - 1, j) Or (parent.pastetype <> p_normal And seltiles(i - 1, j) = 0) Then
        'tile left of it is not in selection
        parent.piclevel.Line (X, Y)-(X, Y + (TileH * parent.magnifier.Zoom))
    End If
    If Not isInSelection(i, j - 1) Or (parent.pastetype <> p_normal And seltiles(i, j - 1) = 0) Then
        'tile top of it is not in selection
        parent.piclevel.Line (X, Y)-(X + (TileH * parent.magnifier.Zoom), Y)
    End If
    If Not isInSelection(i + 1, j) Or (parent.pastetype <> p_normal And seltiles(i + 1, j) = 0) Then
        'tile right of it is not in selection
        parent.piclevel.Line (X + (TileW * parent.magnifier.Zoom) - 1, Y)-(X + (TileW * parent.magnifier.Zoom) - 1, Y + (TileH * parent.magnifier.Zoom))
    End If
    If Not isInSelection(i, j + 1) Or (parent.pastetype <> p_normal And seltiles(i, j + 1) = 0) Then
        'tile bottom of it is not in selection
        parent.piclevel.Line (X, Y + (TileH * parent.magnifier.Zoom) - 1)-(X + (TileW * parent.magnifier.Zoom), Y + (TileH * parent.magnifier.Zoom) - 1)
    End If

   On Error GoTo 0
   Exit Sub

DrawCornerLinesOn_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure DrawCornerLinesOn of Class Module Selection"
End Sub

Sub StopSelecting()

End Sub

Friend Sub SetSelectionData(tiles() As Integer, bitfield() As Boolean, ByRef Bounds As RECT)
   On Error GoTo SetSelectionData_Error

    If hasAlreadySelectedParts Then
        ApplySelection
    End If
    
    seltiles = tiles
    isInSelection = bitfield
    boundaries = Bounds
    
    hasAlreadySelectedParts = True
    selstate = append
    
    parent.pic1024selection.Cls
    Dim i As Integer
    Dim j As Integer
    For j = 0 To 1023
        For i = 0 To 1023
            If isInSelection(i, j) Then
                Call SetPixel(parent.pic1024selection.hdc, i, j, TilePixelColor(seltiles(i, j)))
            End If
        Next
    Next
    parent.pic1024selection.refresh
    
    'move the selection boundaries to the top left of the picpreview,
    'but if a part will be cut off then move it until no parts are being cut off
    Dim lbx As Integer 'lowestval for x
    Dim hbx As Integer 'highestval for x
    Dim lby As Integer 'lowestval for y
    Dim hby As Integer 'highestval for y
    lbx = Int(parent.hScr.value / (TileW * parent.magnifier.Zoom))
    hbx = Int((parent.hScr.value + parent.picpreview.Width) / (TileW * parent.magnifier.Zoom))
    lby = Int(parent.vscr.value / (TileH * parent.magnifier.Zoom))
    hby = Int((parent.vscr.value + parent.picpreview.Height) / (TileH * parent.magnifier.Zoom))

    Dim dx As Integer
    dx = lbx - boundaries.left
    If (boundaries.right + dx) > 1023 Then
        dx = dx - ((boundaries.right + dx) - 1024)
    End If
    
    Dim dY As Integer
    dY = lby - boundaries.top
    If (boundaries.bottom + dY) > 1023 Then
        dY = dY - ((boundaries.bottom + dY) - 1024)
    End If
    Call Move(dx, dY, False)
    
    parent.UpdateLevel

   On Error GoTo 0
   Exit Sub

SetSelectionData_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure SetSelectionData of Class Module Selection"
End Sub

Sub Move(dx As Integer, dY As Integer, Optional refresh As Boolean = True)
   On Error GoTo Move_Error

    
    If dx = 0 And dY = 0 Then
        'no move
        Exit Sub
    End If
    
    If boundaries.left + dx < 0 Then dx = 0 - boundaries.left
    If boundaries.right + dx > 1023 Then dx = 1023 - boundaries.right
    If boundaries.top + dx < 0 Then dY = 0 - boundaries.top
    If boundaries.bottom + dx > 1023 Then dY = 1023 - boundaries.bottom

    If boundaries.left + dx < 0 Or boundaries.top + dY < 0 Or _
       boundaries.right + dx > 1023 Or boundaries.bottom + dY > 1023 Then
       Exit Sub
    End If
    
    Dim newseltiles(1024, 1024) As Integer
    Dim newisInSelection(1024, 1024) As Boolean
        
    Dim i As Integer
    Dim j As Integer
    For j = boundaries.top To boundaries.bottom
        For i = boundaries.left To boundaries.right
            If isInSelection(i, j) Then
                newseltiles(i + dx, j + dY) = seltiles(i, j)
                newisInSelection(i + dx, j + dY) = True
            End If
        Next
    Next
    boundaries.left = boundaries.left + dx
    boundaries.top = boundaries.top + dY
    boundaries.right = boundaries.right + dx
    boundaries.bottom = boundaries.bottom + dY
    
    'apply the new array to the old one
    seltiles = newseltiles
    isInSelection = newisInSelection
    
    
    parent.picseltemp.Cls
    Call BitBlt(parent.picseltemp.hdc, dx, dY, 1024, 1024, parent.pic1024selection.hdc, 0, 0, vbSrcCopy)
    parent.pic1024selection.Cls
    'parent.picseltemp.refresh
    Call BitBlt(parent.pic1024selection.hdc, 0, 0, 1024, 1024, parent.picseltemp.hdc, 0, 0, vbSrcCopy)
    'parent.pic1024selection.refresh
    
    'remember that the selection has been moved
    selectionchanged = True
    
    If refresh Then Call parent.UpdateLevel

   On Error GoTo 0
   Exit Sub

Move_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure Move of Class Module Selection"
End Sub

Sub setSelTile(i As Integer, j As Integer, val As Integer, Optional DrawPixel As Boolean = True)
    seltiles(i, j) = val
 '   isInSelection(i, j) = True
    If DrawPixel Then
        Call SetPixel(parent.pic1024selection.hdc, i, j, TilePixelColor(val))
    End If
End Sub

Function getSelTile(i As Integer, j As Integer) As Integer
    getSelTile = seltiles(i, j)
End Function

Sub SwitchOrReplace(src As Integer, dest As Integer, replace As Boolean)
    'for each isinselection(i,j) between the boundaries replace or switch
    Dim i As Integer
    Dim j As Integer
    Dim m As Long
    Dim n As Long
   On Error GoTo SwitchOrReplace_Error

    n = 0
    m = 0
    
    For j = boundaries.top To boundaries.bottom
        For i = boundaries.left To boundaries.right
            If isInSelection(i, j) Then
                If seltiles(i, j) = src Then
                    Call setSelTile(i, j, dest)
                    n = n + 1
                ElseIf seltiles(i, j) = dest And Not replace Then
                    Call setSelTile(i, j, src)
                    m = m + 1
                End If
            End If
        Next
    Next
    
    If replace Then
        MsgBox n & " tiles replaced.", vbOKOnly + vbInformation, "Tiles replaced"
    Else
        MsgBox n & " tiles A -> B" & vbCrLf & m & " tiles A <- B", vbOKOnly + vbInformation, "Tiles switched"
    End If

    parent.UpdateLevel

   On Error GoTo 0
   Exit Sub

SwitchOrReplace_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure SwitchOrReplace of Class Module Selection"
End Sub

Sub Mirror()
    'mirror entire selection array
    
    Dim i As Integer
    Dim j As Integer
    
    Dim tmp As Integer
    Dim tmpisin As Boolean
    
   On Error GoTo Mirror_Error

    parent.undoredo.ResetRedo
    Dim undoch As Changes
    Set undoch = New Changes
    
    Dim tmpobjects() As Integer
    ReDim tmpobjects(boundaries.left To boundaries.right, boundaries.top To boundaries.bottom)
    
    'first off, calculate the new positions of any objects
    For j = boundaries.top To boundaries.bottom
        For i = boundaries.left To boundaries.right
            tmp = seltiles(i, j)
            
            If tmp = 217 Or tmp = 219 Or tmp = 220 Then
                tmpobjects(boundaries.left + boundaries.right - (i + GetMaxSizeOfObject(tmp)), j) = tmp
                Call DestroySelObject(Me, i, j)
            End If
        Next
    Next

    'flip the selection array
    For j = boundaries.top To boundaries.bottom
        For i = boundaries.left To Int(boundaries.right - ((boundaries.right - boundaries.left) / 2))
            
            tmp = seltiles(i, j)
            tmpisin = isInSelection(i, j)

            isInSelection(i, j) = isInSelection(boundaries.right - (i - boundaries.left), j)
            isInSelection(boundaries.right - (i - boundaries.left), j) = tmpisin
                
            'ignore special objects
            Call setSelTile(i, j, seltiles(boundaries.right - (i - boundaries.left), j))
            Call setSelTile(boundaries.right - (i - boundaries.left), j, tmp)

        Next
    Next
    
    'now that it's flipped we restore the objects
    For j = boundaries.top To boundaries.bottom
        For i = boundaries.left To boundaries.right
            If tmpobjects(i, j) <> 0 Then
                Call setSelObject(Me, tmpobjects(i, j), i, j)
            End If
        Next
    Next

    Call parent.undoredo.AddToUndo(undoch)
    
    selectionchanged = True
    
    Call parent.UpdateLevel

   On Error GoTo 0
   Exit Sub

Mirror_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure Mirror of Class Module Selection"

End Sub

Sub Flip()
    'mirror entire selection array
    
    Dim i As Integer
    Dim j As Integer
    
    Dim tmp As Integer
    Dim tmpisin As Boolean
    
   On Error GoTo Flip_Error

    parent.undoredo.ResetRedo
    Dim undoch As Changes
    Set undoch = New Changes
    
    Dim tmpobjects() As Integer
    ReDim tmpobjects(boundaries.left To boundaries.right, boundaries.top To boundaries.bottom)
    
    'first off, calculate the new positions of any objects
    For j = boundaries.top To boundaries.bottom
        For i = boundaries.left To boundaries.right
            tmp = seltiles(i, j)
            
            If tmp = 217 Or tmp = 219 Or tmp = 220 Then
                tmpobjects(i, boundaries.top + boundaries.bottom - (j + GetMaxSizeOfObject(tmp))) = tmp
                Call DestroySelObject(Me, i, j)
            End If
        Next
    Next

    'flip the selection array
    For i = boundaries.left To boundaries.right
        For j = boundaries.top To Int(boundaries.bottom - ((boundaries.bottom - boundaries.top) / 2))
            
            tmp = seltiles(i, j)
            tmpisin = isInSelection(i, j)

            isInSelection(i, j) = isInSelection(i, boundaries.bottom - (j - boundaries.top))
            isInSelection(i, boundaries.bottom - (j - boundaries.top)) = tmpisin
                
            'ignore special objects
            Call setSelTile(i, j, seltiles(i, boundaries.bottom - (j - boundaries.top)))
            Call setSelTile(i, boundaries.bottom - (j - boundaries.top), tmp)
        Next
    Next
    
    'now that it's flipped we restore the objects
    For j = boundaries.top To boundaries.bottom
        For i = boundaries.left To boundaries.right
            If tmpobjects(i, j) <> 0 Then
                Call setSelObject(Me, tmpobjects(i, j), i, j)
            End If
        Next
    Next

    Call parent.undoredo.AddToUndo(undoch)
    
    selectionchanged = True
    
    Call parent.UpdateLevel

   On Error GoTo 0
   Exit Sub

Flip_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure Flip of Class Module Selection"
End Sub

'etc etc

Sub RotateCW()
    Dim i As Integer
    Dim j As Integer
    
    Dim selctrx As Integer
    Dim selctry As Integer
    Dim newboundaries As RECT

    Dim tmp As Integer
    
    parent.undoredo.ResetRedo
    Dim undoch As Changes
    Set undoch = New Changes


    'New parameters of selection
    selctrx = Int((boundaries.right - boundaries.left) / 2)
    selctry = Int((boundaries.bottom - boundaries.top) / 2)
    newboundaries.left = (selctrx + boundaries.left) - (selctry)
    newboundaries.top = (selctry + boundaries.top) - (selctrx)
    newboundaries.bottom = newboundaries.top + (boundaries.right - boundaries.left)
    newboundaries.right = newboundaries.left + (boundaries.bottom - boundaries.top)
     
    Dim tmptile() As Integer
    Erase tmptile
    ReDim tmptile(boundaries.left To boundaries.right, boundaries.top To boundaries.bottom)
    
    Dim tmpisin() As Boolean
    Erase tmpisin
    ReDim tmpisin(boundaries.left To boundaries.right, boundaries.top To boundaries.bottom)

    Dim tmpobjects() As Integer
    Erase tmpobjects
    ReDim tmpobjects(newboundaries.left To newboundaries.right, newboundaries.top To newboundaries.bottom)
    
    'Make sure new parameters aren't out of bounds
    If newboundaries.left < 0 Then
        newboundaries.left = 0
        newboundaries.right = newboundaries.left + (boundaries.bottom - boundaries.top)
    ElseIf newboundaries.right > 1023 Then
        newboundaries.left = newboundaries.left + (1023 - newboundaries.right)
        newboundaries.right = 1023
    End If
    
    If newboundaries.top < 0 Then
        newboundaries.top = 0
        newboundaries.bottom = newboundaries.top + (boundaries.right - boundaries.left)
    ElseIf newboundaries.bottom > 1023 Then
        newboundaries.top = newboundaries.top + (1023 - newboundaries.bottom)
        newboundaries.bottom = 1023
    End If
    
    'first off, calculate the new positions of any objects
        For i = boundaries.left To boundaries.right
            For j = boundaries.top To boundaries.bottom
                tmp = seltiles(i, j)
                tmpisin(i, j) = isInSelection(i, j)
                If isInSelection(i, j) And (tmp = 217 Or tmp = 219 Or tmp = 220) Then
                
                    '''Special tile found, calculating new coordinates
                        tmpobjects(newboundaries.right - ((j - boundaries.top) + GetMaxSizeOfObject(tmp)), newboundaries.top + (i - boundaries.left)) = tmp
                        Call SearchAndDestroySelObject(Me, i, j)
                Else
    
                    '''Store tile in current selection
                    tmptile(i, j) = seltiles(i, j)
                End If
                
                'Clean that tile off the selection
                isInSelection(i, j) = False
                Call setSelTile(i, j, 0)
            Next
        Next


    
    'Retile the new selection with corresponding tiles
    For j = newboundaries.top To newboundaries.bottom
        For i = newboundaries.left To newboundaries.right
           isInSelection(i, j) = tmpisin(boundaries.left + (j - newboundaries.top), boundaries.top + (newboundaries.right - i))
            If tmptile(boundaries.left + (j - newboundaries.top), boundaries.top + (newboundaries.right - i)) <> -1 Then
                Call setSelTile(i, j, tmptile(boundaries.left + (j - newboundaries.top), boundaries.top + (newboundaries.right - i)))
            End If
 
        Next
    Next
    
    'now that it's flipped we restore the objects
    For j = newboundaries.top To newboundaries.bottom
        For i = newboundaries.left To newboundaries.right
            If tmpobjects(i, j) <> 0 Then
                Call setSelObject(Me, tmpobjects(i, j), i, j)
            End If
        Next
    Next
    
    'Redefine selection with new parameters
    boundaries.left = newboundaries.left
    boundaries.top = newboundaries.top
    boundaries.right = newboundaries.right
    boundaries.bottom = newboundaries.bottom

    Call parent.undoredo.AddToUndo(undoch)
    
    selectionchanged = True
    Call parent.UpdateLevel
End Sub

Sub RotateCCW()
    Dim i As Integer
    Dim j As Integer
    
    Dim selctrx As Integer
    Dim selctry As Integer
    
    Dim newboundaries As RECT
    
    Dim tmp As Integer
    

    
    parent.undoredo.ResetRedo
    Dim undoch As Changes
    Set undoch = New Changes
    

    'New parameters of selection
    selctrx = Int((boundaries.right - boundaries.left) / 2)
    selctry = Int((boundaries.bottom - boundaries.top) / 2)
    newboundaries.left = (selctrx - (selctry - boundaries.left))
    newboundaries.top = (selctry - (selctrx - boundaries.top))
    
    newboundaries.right = newboundaries.left + (boundaries.bottom - boundaries.top)
    newboundaries.bottom = newboundaries.top + (boundaries.right - boundaries.left)
    
    Dim tmptile() As Integer
    Erase tmptile
    ReDim tmptile(boundaries.left To boundaries.right, boundaries.top To boundaries.bottom)
    
    Dim tmpisin() As Boolean
    Erase tmpisin
    ReDim tmpisin(boundaries.left To boundaries.right, boundaries.top To boundaries.bottom)

    Dim tmpobjects() As Integer
    Erase tmpobjects
    ReDim tmpobjects(newboundaries.left To newboundaries.right, newboundaries.top To newboundaries.bottom)
    
    
    'Make sure new parameters aren't out of bounds
    If newboundaries.left < 0 Then
        newboundaries.left = 0
        newboundaries.right = newboundaries.left + (boundaries.bottom - boundaries.top)
    ElseIf newboundaries.right > 1023 Then
        newboundaries.left = newboundaries.left + (1023 - newboundaries.right)
        newboundaries.right = 1023
    End If
    
    If newboundaries.top < 0 Then
        newboundaries.top = 0
        newboundaries.bottom = newboundaries.top + (boundaries.right - boundaries.left)
    ElseIf newboundaries.bottom > 1023 Then
        newboundaries.top = newboundaries.top + (1023 - newboundaries.bottom)
        newboundaries.bottom = 1023
    End If
    

        
    'first off, calculate the new positions of any objects
        For i = boundaries.left To boundaries.right
            For j = boundaries.top To boundaries.bottom
                tmp = seltiles(i, j)
                tmpisin(i, j) = isInSelection(i, j)
                If isInSelection(i, j) And (tmp = 217 Or tmp = 219 Or tmp = 220) Then
                
                    '''Special tile found, calculating new coordinates
                        tmpobjects(newboundaries.left + (j - boundaries.top), newboundaries.bottom - ((i - boundaries.left) + GetMaxSizeOfObject(tmp))) = tmp
                        Call SearchAndDestroySelObject(Me, i, j)
                Else
    
                    '''Store tile in current selection
                    tmptile(i, j) = seltiles(i, j)
                End If
                
                'Clean that tile off the selection
                isInSelection(i, j) = False
                Call setSelTile(i, j, 0)
            Next
        Next

    'Retile the new selection with corresponding tiles
    For j = newboundaries.top To newboundaries.bottom
        For i = newboundaries.left To newboundaries.right
            If tmptile(boundaries.left + (newboundaries.bottom - j), boundaries.top + (i - newboundaries.left)) <> -1 Then
                Call setSelTile(i, j, tmptile(boundaries.left + (newboundaries.bottom - j), boundaries.top + (i - newboundaries.left)))
            End If
            isInSelection(i, j) = tmpisin(boundaries.left + (newboundaries.bottom - j), boundaries.top + (i - newboundaries.left))
        Next
    Next
    
    'now that it's flipped we restore the objects
    For j = newboundaries.top To newboundaries.bottom
        For i = newboundaries.left To newboundaries.right
            If tmpobjects(i, j) <> 0 Then
                Call setSelObject(Me, tmpobjects(i, j), i, j)
            End If
        Next
    Next
    

    'Redefine selection with new parameters
    boundaries.left = newboundaries.left
    boundaries.top = newboundaries.top
    boundaries.right = newboundaries.right
    boundaries.bottom = newboundaries.bottom
    Call parent.undoredo.AddToUndo(undoch)
    
    selectionchanged = True
    Call parent.UpdateLevel
End Sub

Sub Rotate180()
    Dim i As Integer
    Dim j As Integer
    Dim tmp As Integer
    
    Dim tmptile() As Integer
    Erase tmptile
    ReDim tmptile(boundaries.left To boundaries.right, boundaries.top To boundaries.bottom)
    
    Dim tmpisin() As Boolean
    Erase tmpisin
    ReDim tmpisin(boundaries.left To boundaries.right, boundaries.top To boundaries.bottom)

    Dim tmpobjects() As Integer
    Erase tmpobjects
    ReDim tmpobjects(boundaries.left To boundaries.right, boundaries.top To boundaries.bottom)
    
    parent.undoredo.ResetRedo
    Dim undoch As Changes
    Set undoch = New Changes
    
    'first off, calculate the new positions of any objects
    For i = boundaries.left To boundaries.right
        For j = boundaries.top To boundaries.bottom
            tmp = seltiles(i, j)
            tmpisin(i, j) = isInSelection(i, j)
            If isInSelection(i, j) And (tmp = 217 Or tmp = 219 Or tmp = 220) Then
                tmpobjects(boundaries.left + boundaries.right - (i + GetMaxSizeOfObject(tmp)), boundaries.top + boundaries.bottom - (j + GetMaxSizeOfObject(tmp))) = tmp
                Call SearchAndDestroySelObject(Me, i, j)
            Else
                
                'Store tile
                tmptile(i, j) = seltiles(i, j)
            End If
        Next
    Next
    
    'now that the objects are temp gone we can flip the image
    For j = boundaries.top To boundaries.bottom
        For i = boundaries.left To boundaries.right
            Call setSelTile(i, j, tmptile(boundaries.right - (i - boundaries.left), boundaries.bottom - (j - boundaries.top)))
            isInSelection(i, j) = tmpisin(boundaries.right - (i - boundaries.left), boundaries.bottom - (j - boundaries.top))
        Next
    Next
    
    'now that it's flipped we restore the objects
    For i = boundaries.left To boundaries.right
        For j = boundaries.top To boundaries.bottom
            If tmpobjects(i, j) <> 0 Then
                Call setSelObject(Me, tmpobjects(i, j), i, j)
            End If
        Next
    Next
    
    
    Call parent.undoredo.AddToUndo(undoch)
    
    selectionchanged = True
    
    Call parent.UpdateLevel

End Sub

Sub TexTToMap(text() As Integer, Width As Integer, Height As Integer)
    Dim bnds As RECT
    Dim selectiontiles() As Integer
    Dim bitfield() As Boolean
   On Error GoTo TexTToMap_Error

    ReDim selectiontiles(1024, 1024)
    ReDim bitfield(1024, 1024)
    
    bnds.left = 0
    bnds.top = 0
    bnds.right = Width - 1
    bnds.bottom = Height - 1
    
    Dim i As Integer
    Dim j As Integer
    For j = 0 To Height - 1
        For i = 0 To Width - 1
            selectiontiles(i, j) = text(i, j)
            bitfield(i, j) = True
        Next
    Next
    
    Call SetSelectionData(selectiontiles, bitfield, bnds)

   On Error GoTo 0
   Exit Sub

TexTToMap_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure TexTToMap of Class Module Selection"
End Sub

Sub PicToMap(pic() As Integer, Width As Integer, Height As Integer)
    Call TexTToMap(pic(), Width, Height)
End Sub

Sub RemoveObjectSelectionArea(X As Integer, Y As Integer)
    Dim i As Integer
    Dim j As Integer
    Dim coord() As Integer
    Dim coordx As Integer
    Dim coordy As Integer
    Dim size As Integer
    
   On Error GoTo RemoveObjectSelectionArea_Error

    ReDim coord(1) As Integer
    coord = SearchSelObject(Me, X, Y)
    coordx = coord(0)
    coordy = coord(1)
    size = GetMaxSizeOfObject(seltiles(coordx, coordy))
    
    For j = coordy To coordy + size
        For i = coordx To coordx + size
            If isInSelection(i, j) Then
                'copy all the tiles to the level array
                Call parent.setTile(i, j, seltiles(i, j), undoch, False)
                Call parent.UpdateLevelTile(i, j, False)
                'remove the tiles from the selection
                Call setSelTile(i, j, 0, False)
                'flag that they are on the selection
                isInSelection(i, j) = False
                Call SetPixel(parent.pic1024selection.hdc, i, j, vbWhite)
            End If
        Next
    Next

    tempboundaries.left = coordx
    tempboundaries.right = coordx + size
    tempboundaries.top = coordy
    tempboundaries.bottom = coordy + size

    parent.mapchanged = True
   On Error GoTo 0
   Exit Sub

RemoveObjectSelectionArea_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure RemoveObjectSelectionArea of Class Module Selection"
    
End Sub
Sub AddObjectSelectionArea(X As Integer, Y As Integer)
    Dim i As Integer
    Dim j As Integer
    Dim coord() As Integer
    Dim coordx As Integer
    Dim coordy As Integer
    Dim size As Integer
    
   On Error GoTo AddObjectSelectionArea_Error

    ReDim coord(1) As Integer
    coord = SearchObject(parent, X, Y)
    coordx = coord(0)
    coordy = coord(1)
    size = GetMaxSizeOfObject(parent.getTile(coordx, coordy))
    
    For j = coordy To coordy + size
        For i = coordx To coordx + size
            Call setSelTile(i, j, parent.getTile(i, j))
            'remove the tiles from the level
            Call parent.setTile(i, j, 0, undoch, False)
            Call parent.UpdateLevelTile(i, j, False)
            'flag that they are on the selection
            isInSelection(i, j) = True
        Next
    Next

    'Store coordinates to adjust boundaries if needed
    tempboundaries.left = coordx
    tempboundaries.right = coordx + size
    tempboundaries.top = coordy
    tempboundaries.bottom = coordy + size

    parent.mapchanged = True
   On Error GoTo 0
   Exit Sub

AddObjectSelectionArea_Error:

    MsgBox "Error " & Err.Number & " (" & Err.Description & ") in procedure AddObjectSelectionArea of Class Module Selection"
    
End Sub
    
Sub Resize(left As Integer, top As Integer, right As Integer, bottom As Integer)
    'first move selection to left and top, then resize
    Call Move(-boundaries.left + left, -boundaries.top + top, False)
    
    Dim newselection(1024, 1024) As Integer
    Dim newbitfield(1024, 1024) As Boolean

    'get nrOfLinesOnX
    Dim nrOfLinesOnX As Integer
    nrOfLinesOnX = Round(((bottom - top) - (boundaries.bottom - boundaries.top)))
    Dim shrink As Boolean
    If nrOfLinesOnX < 0 Then
        shrink = True
        nrOfLinesOnX = Abs(nrOfLinesOnX)
    Else
        shrink = False
    End If
    
    Dim oldlinecount As Integer
    oldlinecount = 0
    
    Dim i As Integer
    Dim j As Integer
    For j = top To bottom
        If (j - top) Mod Round((bottom - top) / nrOfLinesOnX) = 0 And j <> top And j <> bottom Then
            'we need to add/remove a line
            'check which of lines previous and next has the most
            '0 tiles
            Dim prevnr As Integer
            prevnr = TileCountOnLine(boundaries.top + oldlinecount - 1, 0, False, boundaries)
            Dim nextnr As Integer
            nextnr = TileCountOnLine(boundaries.top + oldlinecount, 0, False, boundaries)
            Dim curline As Integer
            Dim nextnextnr As Integer
            nextnextnr = TileCountOnLine(boundaries.top + oldlinecount + 1, 0, False, boundaries)
            
            If shrink Then
                'skip the line
                oldlinecount = oldlinecount + 1
                
                'check which line to use
                If prevnr <= nextnr And prevnr <> 0 Then 'And boundaries.top + oldlinecount - 1 <= boundaries.bottom Then
                    curline = oldlinecount - 1
                Else
                    curline = oldlinecount
                End If

                'draw the line
                i = boundaries.left
                For i = boundaries.left To boundaries.right
                    If isInSelection(i, boundaries.top + curline) Then
                        newselection(i, j) = seltiles(i, boundaries.top + curline)
                        newbitfield(i, j) = True
                    End If
                Next
                oldlinecount = oldlinecount + 1
            Else
                'check which line to use
                If prevnr >= nextnr And prevnr <> 0 Then 'And boundaries.top + oldlinecount - 1 <= boundaries.bottom Then
                    If prevnr >= nextnextnr Then
                        curline = oldlinecount - 1
                    Else
                        curline = oldlinecount + 1
                    End If
                Else
                    If nextnr >= nextnextnr Then
                        curline = oldlinecount
                    Else
                        curline = oldlinecount + 1
                    End If
                End If

                'draw line
                i = boundaries.left
                For i = boundaries.left To boundaries.right
                    If isInSelection(i, boundaries.top + curline) Then
                        newselection(i, j) = seltiles(i, boundaries.top + curline)
                        newbitfield(i, j) = True
                    End If
                Next
            End If
        Else
            i = boundaries.left
            For i = boundaries.left To boundaries.right
                If isInSelection(i, boundaries.top + oldlinecount) Then
                    newselection(i, j) = seltiles(i, boundaries.top + oldlinecount)
                    newbitfield(i, j) = True
                End If
            Next
            oldlinecount = oldlinecount + 1
        End If
    Next
    
    
    Dim newnewselection(1024, 1024) As Integer
    Dim newnewbitfield(1024, 1024) As Boolean
    
    Dim nrOfLinesOnY As Integer
    nrOfLinesOnY = Round(((right - left) - (boundaries.right - boundaries.left)))
    If nrOfLinesOnY < 0 Then
        shrink = True
        nrOfLinesOnY = Abs(nrOfLinesOnY)
    Else
        shrink = False
    End If
    
    Dim bnds As RECT
    bnds.left = left
    bnds.top = top
    bnds.right = boundaries.right
    bnds.bottom = bottom

    oldlinecount = 0
    j = left
    For j = left To right
        If (j - left) Mod Round((right - left) / nrOfLinesOnY) = 0 And j <> left And j <> right Then
            'we need to add/remove a line
            'check which of lines previous and next has the most
            '0 tiles
            prevnr = TileCountOnLine(bnds.left + oldlinecount - 1, 0, True, bnds)
            nextnr = TileCountOnLine(bnds.left + oldlinecount, 0, True, bnds)
            nextnextnr = TileCountOnLine(bnds.left + oldlinecount + 1, 0, True, bnds)
            If shrink Then
                'skip a line
                oldlinecount = oldlinecount + 1
                
                If prevnr <= nextnr And prevnr <> 0 Then 'And bnds.left + oldlinecount - 1 <= bnds.right Then
                    curline = oldlinecount - 1
                Else
                    curline = oldlinecount
                End If
                
                'draw the line
                i = bnds.top
                For i = bnds.top To bnds.bottom
                    If newbitfield(bnds.left + curline, i) Then
                        newnewselection(j, i) = newselection(bnds.left + curline, i)
                        newnewbitfield(j, i) = True
                    End If
                Next
                oldlinecount = oldlinecount + 1
            Else
                'check which line to use
                If prevnr >= nextnr And prevnr <> 0 Then 'And bnds.left + oldlinecount - 1 <= bnds.right Then
                    If prevnr >= nextnextnr Then
                        curline = oldlinecount - 1
                    Else
                        curline = oldlinecount + 1
                    End If
                Else
                    If nextnr >= nextnextnr Then
                        curline = oldlinecount
                    Else
                        curline = oldlinecount + 1
                    End If
                End If

                'draw the line
                i = bnds.top
                For i = bnds.top To bnds.bottom
                    If newbitfield(bnds.left + curline, i) Then
                        newnewselection(j, i) = newselection(bnds.left + curline, i)
                        newnewbitfield(j, i) = True
                    End If
                Next
            End If
        Else
            i = bnds.top
            For i = bnds.top To bnds.bottom
                If newbitfield(bnds.left + oldlinecount, i) Then
                    newnewselection(j, i) = newselection(bnds.left + oldlinecount, i)
                    newnewbitfield(j, i) = True
                End If
            Next
            oldlinecount = oldlinecount + 1
        End If
    Next
    
    bnds.left = left
    bnds.top = top
    bnds.right = right
    bnds.bottom = bottom
    
    seltiles = newnewselection
    isInSelection = newnewbitfield
    boundaries = bnds
    
    parent.pic1024selection.Cls
    Dim k As Integer
    Dim l As Integer
    For l = bnds.top To bnds.bottom
        For k = bnds.left To bnds.right
            Call SetPixel(parent.pic1024selection.hdc, k, l, TilePixelColor(seltiles(k, l)))
        Next
    Next
    parent.pic1024selection.refresh
    
    parent.UpdateLevel
End Sub

Friend Function TileCountOnLine(j As Integer, tile As Integer, vert As Boolean, boundaries As RECT)
    Dim i As Integer
    Dim count As Integer
    
    If vert Then
        For i = boundaries.top To boundaries.bottom
            If seltiles(j, i) = tile Then
                count = count + 1
            End If
        Next
    Else
        For i = boundaries.left To boundaries.right
            If seltiles(i, j) = tile Then
                count = count + 1
            End If
        Next
    End If
    TileCountOnLine = count
End Function
